package com.liang.service;

import com.liang.entity.PrjCompletecompany;
import com.liang.entity.PrjMember;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * 完成单位(PrjCompletecompany)表服务接口
 *
 * @author makejava
 * @since 2023-03-10 11:21:40
 */
public interface PrjCompletecompanyService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PrjCompletecompany queryById(Integer id);

    /**
     * 通过xm查询单条数据
     *
     * @param xm
     * @return 实例对象
     */
    List<PrjCompletecompany> queryByXM(Integer xm);


    /**
     * 分页查询
     *
     * @param prjCompletecompany 筛选条件
     * @param pageRequest        分页对象
     * @return 查询结果
     */
    Page<PrjCompletecompany> queryByPage(PrjCompletecompany prjCompletecompany, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param prjCompletecompany 实例对象
     * @return 实例对象
     */
    int insert(PrjCompletecompany prjCompletecompany);

    /**
     * 修改数据
     *
     * @param prjCompletecompany 实例对象
     * @return 实例对象
     */
    PrjCompletecompany update(PrjCompletecompany prjCompletecompany);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    /**
     * 通过项目删除数据
     *
     * @param xm
     * @return
     */
    int deleteByXm(Integer xm);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param companyList List<PrjCompletecompany> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PrjCompletecompany> companyList);

    /**
     * 获取项目任务书完成单位
     *
     * @param map
     * @return
     */
    List<PrjCompletecompany> getCompanyList(Map map);

    /**
     * 批量删除项目完成单位
     *
     * @param xmList
     * @return
     */
    int batchDeleteByXm(List<Integer> xmList);

    List<PrjCompletecompany> getCompanyListFy(Integer xm);
}
